/////////////////////////////////////////////////////////////////////////////:
//
//  IH_connect.cpp
//
//     
//  This file is about the management of the internet protocol
//	
//
//  february 2005 - martin hachet
//
//
//

#ifdef __cplusplus
extern "C"{
#endif

#include <windows.h>
#include <winsock.h>
#include <string.h>
#include <commdlg.h>
#include <commctrl.h>
#include <stdio.h>
#include <stdlib.h>


#include "connect.h"

#pragma comment(lib,"wsock32.lib")
// INET


bool CONNECTED;
SOCKET csock;
char *recievedString;


WSADATA* WinSockInit(void)
{	
	WORD wVersionRequested = 0x0101;
	WSADATA *wsaData;
	wsaData = new(WSADATA);
	if(WSAStartup(wVersionRequested,wsaData)!=0) 
		return NULL;
	return wsaData;
}

void WinSockClose(void)
{
	WSACleanup();
}


// - input  : string with the adress
// - output : IP within the ULONG format  
u_long Resolve(char *adrs)
{
	hostent *he;
	u_long IP;
	if((IP=inet_addr(adrs))!=INADDR_NONE)	//type "a.b.c.d"
		return(IP);
	if((he=gethostbyname(adrs))!=NULL)		//type "ccc.bbb.aaa"
		return(*(DWORD*)he->h_addr);
	return(0);
}

SOCKET CreateSocket()
{
	return socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
}

void CloseSocket(SOCKET s)
{
	closesocket(s);
}

BOOL ConnectSocket(SOCKET Socket, char *Adress, unsigned short Port)
{
	u_long IP = Resolve(Adress);
	struct sockaddr_in Socket_Address;
  	ZeroMemory(&Socket_Address,sizeof(struct sockaddr_in));
	Socket_Address.sin_family=AF_INET;
	Socket_Address.sin_addr.s_addr=IP;
  	Socket_Address.sin_port=htons(Port);

	if((connect(Socket,(sockaddr*)&Socket_Address,sizeof(struct sockaddr_in)))==0)
   		return TRUE;

  	return FALSE;
}

SOCKET CreateAndConnectSocket(char *adrs, u_short port)
{
	SOCKET s = CreateSocket();
	if(ConnectSocket(s, adrs, port)) 
		return s;
	return 0;
}


void SendText(SOCKET s, char *string, ...)
{ 
	va_list va;
	va_start(va,string);
	char *txt = (char*)malloc(4096);
	_vsnprintf(txt, 4096, string, va);
	send(s, txt, strlen(txt),0);
	free(txt);
}

int ReceiveText(SOCKET s, char *txt, int len)
{
	return recv(s, txt, len, 0);
}


void CloseConnexion()
{
	CloseSocket(csock);
	WinSockClose();	
}


int
InitConnexion()
{	
	int i=0;
	CONNECTED = FALSE;

	WinSockInit();

	csock = CreateAndConnectSocket(SERVER, PORT);

	if(csock)
	{
		CONNECTED = true;
		recievedString = (char*)malloc(2);
		return 1;
	}
		
	return 0;
}

#ifdef __cplusplus
}
#endif
